package com.hys.app.model.erp.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.hys.app.framework.database.mybatisplus.base.BaseDO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * 部门表
 */
@TableName(value = "erp_company_package")
@Data
@EqualsAndHashCode(callSuper = true)
public class CompanyPackage extends BaseDO {

    public static final Long ROOT_ID = 0L;

    private Long id;
    /**
     * 权限id
     */
    private Long roleId;
    /**
     * 套餐金额
     */
    private BigDecimal money;
    /**
     * 购买天数
     */
    private Integer day;

    /**
     * 状态
     */
    private Boolean useAble;

    private String name;

    private String remark;

    /**
     * 最大创建账号数
     */
    @ApiModelProperty("最大创建账号数")
    @NotNull(message = "最大创建账号数不能为空")
    private Integer userNum;
}
