package com.hys.app.model.erp.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * 部门表
 */
@Data
public class CompanyPackageDO {

    /**
     * 最大创建账号数
     */
    @ApiModelProperty("最大创建账号数")
    @NotNull(message = "最大创建账号数不能为空")
    private Integer userNum;

    /**
     * 权限id
     */
    @ApiModelProperty("权限id")
    @NotNull(message = "权限id不能为空")
    private Long roleId;
    /**
     * 套餐金额
     */
    @ApiModelProperty("套餐金额")
    @NotNull(message = "套餐金额不能为空")
    private BigDecimal money;
    /**
     * 购买天数
     */
    @ApiModelProperty("购买天数")
    @NotNull(message = "购买天数不能为空")
    private Integer day;

    @ApiModelProperty("状态")
    @NotNull(message = "状态不能为空")
    private Boolean useAble;

    @ApiModelProperty("套餐名称")
    @NotBlank(message = "套餐名称不能为空")
    private String  name;

    @ApiModelProperty("备注")
    private String  remark;
}
