package com.hys.app.service.otherService.amazon;

import com.baomidou.mybatisplus.annotation.TableName;
import com.hys.app.framework.database.annotation.Column;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

@TableName(value = "erp_company")
@Data
public class OwnProduct {

    public static final Long ROOT_ID = 0L;

    private Long id; // 产品唯一标识符

    private String sku; // 库存单位，唯一标识产品的编码

    private String name; // 产品名称

    private String description; // 产品描述

    private List<String> bulletPoints; // 产品要点列表，用于突出产品特性

    private BigDecimal price; // 产品价格

    private BigDecimal salePrice; // 促销价格

    private Integer lowStockThreshold; // 低库存警戒线

    private String brand; // 品牌

    private String manufacturer; // 制造商

    private String category; // 产品类别

    private String picUrl; // 产品图片URL列表

    private BigDecimal weight; // 重量

    private String weightUnit; // 重量单位

    private BigDecimal length; // 长度
    private BigDecimal width;  // 宽度
    private BigDecimal height; // 高度

    private String dimensionUnit; // 尺寸单位

    private String color; // 颜色
    private String size;  // 尺寸

    private List<String> keywords; // 搜索关键词列表

    private String upc; // 通用产品代码
    private String ean; // 欧洲商品编号
    private String isbn; // 国际标准书号

    private Integer quantityPerPackage; // 每包数量

    private Integer packageQuantity; // 包装数量

    private String countryOfOrigin; // 原产国

    private String warranty; // 保修信息

    private String fulfillmentType; // 履行类型，如亚马逊的FBA、FBM

    private Map<String, String> platformSpecificIds; // 平台特定ID，如{"AMAZON": "ASIN12345", "EBAY": "EB67890"}

    private Map<String, String> customAttributes; // 自定义属性，用于存储额外的平台特定信息

    private LocalDateTime createdAt; // 创建时间

    private LocalDateTime updatedAt; // 最后更新时间

}